VERSION 5.00
Begin VB.Form frmClasses_BatchUpdate 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Batch Update Classes"
   ClientHeight    =   1890
   ClientLeft      =   150
   ClientTop       =   150
   ClientWidth     =   4770
   HelpContextID   =   610
   Icon            =   "Batch Update Classes.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1890
   ScaleWidth      =   4770
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox cboNewClass 
      Height          =   315
      Left            =   1500
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   660
      Width           =   2655
   End
   Begin VB.ComboBox cboCurrentClass 
      Height          =   315
      Left            =   1500
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   180
      Width           =   2655
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1560
      TabIndex        =   1
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3000
      TabIndex        =   4
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   180
      TabIndex        =   3
      Top             =   1200
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "New Class"
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   720
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Current Class"
      Height          =   195
      Left            =   180
      TabIndex        =   2
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "frmClasses_BatchUpdate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Executes a query that moves all of the students in the specified class
'to the specified target class

Option Explicit

Private Loading As Boolean

Private Sub cmdClose_Click()
    'Unload form from memory and display
    Unload Me
End Sub


Private Sub cmdHelp_Click()
    ShowHelpTopic 610
End Sub

Private Sub cmdUpdate_Click()
    'Builds and Executes the update querr
    Dim strSQL As String
    Dim strMsg As String
    
    If cboCurrentClass.ListIndex = -1 Then
        strMsg = "Please select the current class of the students you wish to move"
        MsgBox strMsg, vbExclamation, "Missing Input"
    ElseIf cboNewClass.ListIndex = -1 Then
        strMsg = "Please select the new class of the students you wish to move"
        MsgBox strMsg, vbExclamation, "Missing Input"
    Else
        strSQL = "UPDATE [Students] " _
                & "SET   [Class] = '" & cboNewClass.List(cboNewClass.ListIndex) & "'" _
                & "WHERE [Class] = '" & cboCurrentClass.List(cboCurrentClass.ListIndex) & "'"
        qryQueryObject.SQL = strSQL
        
        Screen.MousePointer = vbHourglass
        qryQueryObject.Execute
        Screen.MousePointer = vbDefault
        
        strMsg = "Successfully moved" & Str(qryQueryObject.RecordsAffected) _
               & " student(s) from " & cboCurrentClass.List(cboCurrentClass.ListIndex) _
               & " to " & cboNewClass.List(cboNewClass.ListIndex)
        MsgBox strMsg, vbInformation, "Update Classes"
    End If
                
End Sub

Private Sub Form_Activate()
    Dim strMsg As String
    'Ensure that the system actually has some registered students. If it doesn't
    'abort. If it does then load the lists of available classes into the combo boxes.
    
    If CurrentUser.Allowed_Classes_BatchUpdate Then
        If Loading Then
            Loading = False
            If rstStudents.RecordCount = 0 Then
                strMsg = "You currently have no students registered. Register some students first."
                MsgBox strMsg, vbCritical, "Batch Update Classes"
                Unload Me
            Else
                Call LoadListOfAvailableClasses(Me.cboCurrentClass)
                Call LoadListOfAvailableClasses(Me.cboNewClass)
            End If
        End If
    Else
        strMsg = "You have not been authorised to batch update classes."
        MsgBox strMsg, vbCritical, "Access denied"
        Unload Me
    End If
                        
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Local Error Resume Next
    frmSystem_MainMenu.SetFocus
End Sub
