VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmDeposits 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Deposit Account Management"
   ClientHeight    =   3105
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   7305
   HelpContextID   =   1020
   Icon            =   "Deposit Accounts.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3105
   ScaleWidth      =   7305
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3060
      TabIndex        =   2
      Top             =   2460
      Width           =   1275
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5040
      TabIndex        =   1
      Top             =   2460
      Width           =   1275
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   960
      TabIndex        =   0
      Top             =   2460
      Width           =   1275
   End
   Begin MSFlexGridLib.MSFlexGrid grdHeader 
      Height          =   1815
      Left            =   300
      TabIndex        =   3
      Top             =   180
      Width           =   6615
      _ExtentX        =   11668
      _ExtentY        =   3201
      _Version        =   393216
      Rows            =   7
      FixedRows       =   0
      GridColor       =   0
      AllowUserResizing=   1
   End
   Begin VB.Menu mnuTools 
      Caption         =   "&Tools"
      Begin VB.Menu mnuTools_DebitAccount 
         Caption         =   "&Debit Account"
      End
      Begin VB.Menu mnuTools_CreditAccount 
         Caption         =   "&Credit Account"
      End
      Begin VB.Menu mnuTools_StatementOfAccount 
         Caption         =   "&Statement of Account"
      End
      Begin VB.Menu mnuTools_Sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Help 
         Caption         =   "&Help"
      End
      Begin VB.Menu mnuTools_Sep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Close 
         Caption         =   "&Close"
      End
   End
End
Attribute VB_Name = "frmDeposits"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Presents an interface from which the user can access facilities related
'to an individual caution deposit account
Option Explicit

Private Loading As Boolean

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 1020
End Sub

Private Sub cmdLoad_Click()
    Dim strStudentID As String
    
    'get student id
    strStudentID = Trim(InputBox("Enter Student ID", "Load Account", "", , , getHelpFilePath, 1030))
    If strStudentID <> "" Then
        'delegate actual loading
        LoadStudentDetails (strStudentID)
    End If
    
End Sub

Private Sub LoadStudentDetails(strStudentID As String, Optional Refreshing As Boolean)
    'the refreshing optional parameter is used to indicate that a previously loaded account
    'is just having its values updated on the display
    
    Dim strMsg As String
    Dim curMinBalance As Currency
    Dim curCurrentBalance As Currency
    Dim curBalanceDifference As Currency
    Dim curDifferenceDescription As String
        
    If IsMissing(Refreshing) Then Refreshing = False
    
    If InvalidStudentID(strStudentID, True) Then
        If Refreshing Then
            strMsg = "The Student is nolonger registered with the system"
            Call BlankOutGrid(grdHeader)
        Else
            strMsg = "The requested student ID is not registered with the system"
        End If
        MsgBox strMsg, vbExclamation, "Load Account"
    Else
        'enter student's details
        Call EnterGridData(grdHeader, 0, 0, "Student ID")
        Call EnterGridData(grdHeader, 0, 1, rstStudents("Student ID"))
        
        Call EnterGridData(grdHeader, 1, 0, "Name")
        Call EnterGridData(grdHeader, 1, 1, rstStudents("Surname") & " " & rstStudents("First Names"))
        
        Call EnterGridData(grdHeader, 2, 0, "Class")
        Call EnterGridData(grdHeader, 2, 1, rstStudents("Class"))
        
        Call EnterGridData(grdHeader, 3, 0, "Statement Period")
               
        'Balance info section
        curCurrentBalance = getDepositAccountBalance(rstStudents("Student ID"))
        curMinBalance = getClassMinBalance(rstStudents("Class"))
        curBalanceDifference = curCurrentBalance - curMinBalance
        If curCurrentBalance < curMinBalance Then
            curDifferenceDescription = "Current Shortfall"
            Call SetGridForeColor(grdHeader, 6, 1, vbRed)
        Else
            curDifferenceDescription = "Current Excess"
            Call SetGridForeColor(grdHeader, 6, 1, vbBlue)
        End If
        
        
        Call EnterGridData(grdHeader, 4, 0, "Current Balance")
        Call EnterGridData(grdHeader, 4, 1, CurrencyFormat(curCurrentBalance))
        
        Call EnterGridData(grdHeader, 5, 0, "Minimum Balance")
        Call EnterGridData(grdHeader, 5, 1, CurrencyFormat(curMinBalance))
        
        Call EnterGridData(grdHeader, 6, 0, curDifferenceDescription)
        Call EnterGridData(grdHeader, 6, 1, CurrencyFormat(curBalanceDifference, , moneyExcludeType))
    End If

End Sub



Private Sub Form_Activate()
    'initialises column width and alignment
    If Loading Then
        Loading = False
        grdHeader.ColWidth(0) = 1845
        grdHeader.ColWidth(1) = 4650
        grdHeader.ColAlignment(0) = flexAlignLeftCenter
        grdHeader.ColAlignment(1) = flexAlignLeftCenter
    End If
    
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    frmSystem_MainMenu.SetFocus
End Sub

Private Sub mnuTools_Close_Click()
    cmdClose.Value = True
End Sub

Private Function GridEmpty() As Boolean
    'Assumes that you cannot have a situation in which the student id is
    'not being deisplayed when an account is actually loaded
    If Trim(GetGridData(grdHeader, 0, 1)) = "" Then
        GridEmpty = True
    Else
        GridEmpty = False
    End If
    
End Function

Private Sub mnuTools_CreditAccount_Click()
    Dim strMsg As String
    If CurrentUser.Allowed_DepositAc_Credit Then
        If Not GridEmpty Then
            'delegate task
            frmDeposits_Credit.Show vbModal, Me
            'refresh display
            Call LoadStudentDetails(GetGridData(grdHeader, 0, 1), True)
        Else
            strMsg = "Please load an account first"
            MsgBox strMsg, vbExclamation, "Credit Account"
        End If
    Else
        GiveSecViolationMsg "credit deposit accounts"
    End If
        
End Sub

Private Sub mnuTools_DebitAccount_Click()
    Dim strMsg As String
    
    If CurrentUser.Allowed_DepositAc_Debit Then
        If Not GridEmpty Then
            'delegate
            frmDeposits_Debit.Show vbModal, Me
            'refresh display
            Call LoadStudentDetails(GetGridData(grdHeader, 0, 1), True)
        Else
            strMsg = "Please load an account first"
            MsgBox strMsg, vbExclamation, "Debit Account"
        End If
    Else
        GiveSecViolationMsg "debit deposit accounts"
    End If
    
End Sub

Private Sub mnuTools_Help_Click()
    cmdHelp.Value = True
End Sub

Private Sub mnuTools_StatementOfAccount_Click()
    Dim strMsg As String
        
    If CurrentUser.Allowed_DepositAc_IndividualStmt Then
        If Not GridEmpty Then
            'delegate
            frmDeposits_Statement_Load.Show vbModal, Me
            'refresh display
            Call LoadStudentDetails(GetGridData(grdHeader, 0, 1), True)
        Else
            strMsg = "Please load an account first"
            MsgBox strMsg, vbExclamation, "Load Statement"
        End If
    Else
        GiveSecViolationMsg "generate individual statements of accounts"
    End If

End Sub
