VERSION 5.00
Begin VB.Form frmLevy_Charge_LoadTemplate 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Load Template"
   ClientHeight    =   3975
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5970
   HelpContextID   =   890
   Icon            =   "Load Template Data.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3975
   ScaleWidth      =   5970
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4448
      TabIndex        =   3
      Top             =   3300
      Width           =   1155
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2408
      TabIndex        =   2
      Top             =   3300
      Width           =   1155
   End
   Begin VB.CommandButton cmdLoadTemplate 
      Caption         =   "Load"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   368
      TabIndex        =   1
      Top             =   3300
      Width           =   1155
   End
   Begin VB.ListBox lstAvailableTemplates 
      Height          =   2400
      Left            =   420
      TabIndex        =   0
      Top             =   420
      Width           =   5055
   End
   Begin VB.Frame Frame1 
      Caption         =   "Available Templates"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2895
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   5715
   End
End
Attribute VB_Name = "frmLevy_Charge_LoadTemplate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Loading As Boolean

Private Sub cmdCancel_Click()
    Unload Me
End Sub


Private Sub cmdHelp_Click()
    ShowHelpTopic 890
End Sub

Private Sub cmdLoadTemplate_Click()
    Dim strTemplateData As String
    Dim lngRowCounter As Long
    Dim strTemplateArray() As String
    
    'Ensure that a template has been selected first
    If lstAvailableTemplates.ListIndex = -1 Then
        MsgBox "Please select a template first", vbExclamation, "Load Template"
    Else
        'Locate template record and retrieve it
        rstFeesTemplates.Seek "=", lstAvailableTemplates.List(lstAvailableTemplates.ListIndex)
        strTemplateData = rstFeesTemplates("Template Data")
        
        'Retrieve contents of template and place in array
        strTemplateArray = GenerateTemplateArray(strTemplateData)
        
        'Ensure that template will not duplicate any fees
        If Not ArrayWillCauseDuplicates(strTemplateArray) Then
            'Place contents of array into parent's grid
            InsertTemplateDataIntoGrid strTemplateArray
        End If
        
        'Return control to parent form
        Unload Me
    End If
        
End Sub

Private Function ArrayWillCauseDuplicates(strTemplateArray() As String) As Boolean
    Dim lngRowCounter As Long
    Dim strFeeName As String
    Dim strMsg As String
    Dim blnDuplicateFound As Boolean
        
    'take each entry in the array and check if it exists in the grid
    frmLevy_Charge.grdCharges.Col = 0
    
    For lngRowCounter = 1 To UBound(strTemplateArray, 2)
        strFeeName = strTemplateArray(1, lngRowCounter)
        
        frmLevy_Charge.grdCharges.Row = 1
        While frmLevy_Charge.grdCharges.Text <> "" And Not blnDuplicateFound
            If TextTheSame(strFeeName, frmLevy_Charge.grdCharges.Text) Then
                blnDuplicateFound = True
                strMsg = "Loading this template will duplicate the following fee: " _
                       & strFeeName
                MsgBox strMsg, vbExclamation, "Load Template"
            End If
            frmLevy_Charge.grdCharges.Row = frmLevy_Charge.grdCharges.Row + 1
        Wend
        
        If blnDuplicateFound Then Exit For
    Next
    
    If blnDuplicateFound Then
        ArrayWillCauseDuplicates = True
    Else
        ArrayWillCauseDuplicates = False
    End If
    
End Function

Private Sub Form_Activate()

    If Loading Then
        Loading = False
        rstFeesTemplates.Index = "Template Name Index"
        rstFeesTemplates.MoveFirst
        'List available templates
        Do
            lstAvailableTemplates.AddItem rstFeesTemplates("Template Name")
            rstFeesTemplates.MoveNext
        Loop Until rstFeesTemplates.EOF
    End If
    
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub InsertTemplateDataIntoGrid(strTemplateArray() As String)
    
    Dim intRowCounter As Long
    
    'Locate insertion Point into grid
    frmLevy_Charge.grdCharges.Col = 0
    frmLevy_Charge.grdCharges.Row = 1
    While Trim(frmLevy_Charge.grdCharges.Text) <> ""
        frmLevy_Charge.grdCharges.Row = frmLevy_Charge.grdCharges.Row + 1
    Wend
            
    'Begin inserting into array
    For intRowCounter = 1 To UBound(strTemplateArray, 2)
        'Enter Fee Name
        frmLevy_Charge.grdCharges.Col = 0
        frmLevy_Charge.grdCharges.Text = strTemplateArray(1, intRowCounter)
        
        'Enter fee Amount
        frmLevy_Charge.grdCharges.Col = 1
        frmLevy_Charge.grdCharges.Text = strTemplateArray(2, intRowCounter)
        
        'move to next row
        frmLevy_Charge.grdCharges.Row = frmLevy_Charge.grdCharges.Row + 1
    Next
            
    
End Sub

Private Function GenerateTemplateArray(strTemplateData As String) As String()
    Dim strMsg As String
    
    Dim strTemplateArray() As String
    Dim blnArrayStillEmpty As Boolean
    
    Dim lngCurrentPosition As Long
    Dim strCurrentCharacter As String * 1
    Dim lngLastPosition As Long
    Dim lngFeeCode As Long
    Dim strFeeName As String
    Dim strAmount As String
    
    blnArrayStillEmpty = True
    rstRegisteredFees.Index = "Fee Code Index"
    lngCurrentPosition = 1
    lngLastPosition = 1
    Do
        strCurrentCharacter = Mid(strTemplateData, lngCurrentPosition, 1)
        If strCurrentCharacter = "," Then
            'isolate fee code
            lngFeeCode = Val(Mid(strTemplateData, lngLastPosition, lngCurrentPosition - lngLastPosition))
            
            'Get fee name and place it in the array
            rstRegisteredFees.Seek "=", lngFeeCode
            If rstRegisteredFees.NoMatch Then
                strMsg = "This template contains invalid data. Please delete it"
                MsgBox strMsg, vbCritical, "System Error"
                Unload Me
            Else
                strFeeName = rstRegisteredFees("Fee Name")
                'if this is first entry then dimension without preserve
                If blnArrayStillEmpty Then
                    ReDim strTemplateArray(1 To 2, 1 To 1)
                    blnArrayStillEmpty = False
                Else
                    'Add a blank row to the array
                    ReDim Preserve strTemplateArray(1 To 2, 1 To UBound(strTemplateArray, 2) + 1)
                End If
                
                'add fee name to array
                strTemplateArray(1, UBound(strTemplateArray, 2)) = strFeeName
                
                lngLastPosition = lngCurrentPosition + 1
            End If
        ElseIf strCurrentCharacter = ";" Then
            'rip out amount
            strAmount = Mid(strTemplateData, lngLastPosition, lngCurrentPosition - lngLastPosition)
            
            'place amount in array
            strTemplateArray(2, UBound(strTemplateArray, 2)) = strAmount
            
            lngLastPosition = lngCurrentPosition + 1
        End If
        lngCurrentPosition = lngCurrentPosition + 1
    Loop Until lngCurrentPosition > Len(strTemplateData)
    
    GenerateTemplateArray = strTemplateArray
    
End Function

Private Sub lstAvailableTemplates_Click()
    cmdLoadTemplate.Value = True
End Sub
